Name:          litert
Version:       2.17.0
Release:       1%{?dist}
Summary:       high-performance runtime for on-device AI
URL:           https://github.com/google-ai-edge/LiteRT
Source0:       https://github.com/tensorflow/tensorflow/archive/v%{version}/tensorflow-%{version}.tar.gz
Source1:       litert.pc
License:       Apache-2.0

Provides:      %{name} = %{version}-%{release}
Provides:      %{name}%{_isa} = %{version}-%{release}

BuildRequires: cmake
BuildRequires: git
BuildRequires: clang
BuildRequires: llvm
BuildRequires: patchelf

%description
LiteRT (short for Lite Runtime) is the new name for TensorFlow Lite
(TFLite). While the name is new, it's still the same trusted,
high-performance runtime for on-device AI, now with an expanded
vision.

Since its debut in 2017, TFLite has enabled developers to bring
ML-powered experiences to over 100K apps running on 2.7B devices. More
recently, TFLite has grown beyond its TensorFlow roots to support
models authored in PyTorch, JAX, and Keras with the same leading
performance. The name LiteRT captures this multi-framework vision for
the future: enabling developers to start with any popular framework
and run their model on-device with exceptional performance.

LiteRT, part of the Google AI Edge suite of tools, is the runtime that
lets you seamlessly deploy ML and AI models on Android, iOS, and
embedded devices. With AI Edge's robust model conversion and
optimization tools, you can ready both open-source and custom models
for on-device development.

%package devel
Summary:       Development files for %{name}
Provides:      %{name}-devel = %{version}-%{release}
Provides:      %{name}-devel%{_isa} = %{version}-%{release}
Requires:      %{name}%{?_isa} = %{version}-%{release}

%description devel
%{summary}.

%prep
%autosetup -n tensorflow-%{version}
%cmake tensorflow/lite

%build
%cmake_build

%install
install -d $RPM_BUILD_ROOT/%{_includedir}/tensorflow/lite
install tensorflow/lite/*.h $RPM_BUILD_ROOT/%{_includedir}/tensorflow/lite

install -d $RPM_BUILD_ROOT/%{_includedir}/tensorflow/lite/c
install tensorflow/lite/c/{common.h,builtin_op_data.h,c_api.h,c_api_experimental.h} $RPM_BUILD_ROOT/%{_includedir}/tensorflow/lite/c

install -d $RPM_BUILD_ROOT/%{_includedir}/tensorflow/lite/core/async/c
install tensorflow/lite/core/async/c/*.h $RPM_BUILD_ROOT/%{_includedir}/tensorflow/lite/core/async/c

install -d $RPM_BUILD_ROOT/%{_includedir}/tensorflow/lite/core/c
install tensorflow/lite/core/c/*.h $RPM_BUILD_ROOT/%{_includedir}/tensorflow/lite/core/c

install -d $RPM_BUILD_ROOT/%{_includedir}/tensorflow/lite/delegates/external
install tensorflow/lite/delegates/external/*.h $RPM_BUILD_ROOT/%{_includedir}/tensorflow/lite/delegates/external

install -d $RPM_BUILD_ROOT/%{_libexecdir}/litert
install redhat-linux-build/_deps/farmhash-build/libfarmhash.so $RPM_BUILD_ROOT/%{_libexecdir}/litert
install redhat-linux-build/_deps/fft2d-build/libfft2d_fftsg2d.so $RPM_BUILD_ROOT/%{_libexecdir}/litert
install redhat-linux-build/_deps/xnnpack-build/libXNNPACK.so $RPM_BUILD_ROOT/%{_libexecdir}/litert
install redhat-linux-build/_deps/abseil-cpp-build/absl/container/libabsl_raw_hash_set.so $RPM_BUILD_ROOT/%{_libexecdir}/litert
install redhat-linux-build/_deps/abseil-cpp-build/absl/hash/libabsl_hash.so $RPM_BUILD_ROOT/%{_libexecdir}/litert
install redhat-linux-build/_deps/abseil-cpp-build/absl/synchronization/libabsl_synchronization.so $RPM_BUILD_ROOT/%{_libexecdir}/litert
install redhat-linux-build/_deps/abseil-cpp-build/absl/strings/libabsl_strings.so $RPM_BUILD_ROOT/%{_libexecdir}/litert
install redhat-linux-build/_deps/fft2d-build/libfft2d_fftsg.so $RPM_BUILD_ROOT/%{_libexecdir}/litert
install redhat-linux-build/pthreadpool/libpthreadpool.so $RPM_BUILD_ROOT/%{_libexecdir}/litert
install redhat-linux-build/_deps/cpuinfo-build/libcpuinfo.so $RPM_BUILD_ROOT/%{_libexecdir}/litert

install redhat-linux-build/_deps/abseil-cpp-build/absl/hash/libabsl_city.so $RPM_BUILD_ROOT/%{_libexecdir}/litert
install redhat-linux-build/_deps/abseil-cpp-build/absl/hash/libabsl_low_level_hash.so $RPM_BUILD_ROOT/%{_libexecdir}/litert
install redhat-linux-build/_deps/abseil-cpp-build/absl/synchronization/libabsl_kernel_timeout_internal.so $RPM_BUILD_ROOT/%{_libexecdir}/litert
install redhat-linux-build/_deps/abseil-cpp-build/absl/debugging/libabsl_stacktrace.so $RPM_BUILD_ROOT/%{_libexecdir}/litert
install redhat-linux-build/_deps/abseil-cpp-build/absl/time/libabsl_time.so $RPM_BUILD_ROOT/%{_libexecdir}/litert
install redhat-linux-build/_deps/abseil-cpp-build/absl/base/libabsl_malloc_internal.so $RPM_BUILD_ROOT/%{_libexecdir}/litert
install redhat-linux-build/_deps/abseil-cpp-build/absl/base/libabsl_base.so $RPM_BUILD_ROOT/%{_libexecdir}/litert
install redhat-linux-build/_deps/abseil-cpp-build/absl/base/libabsl_spinlock_wait.so $RPM_BUILD_ROOT/%{_libexecdir}/litert
install redhat-linux-build/_deps/abseil-cpp-build/absl/base/libabsl_raw_logging_internal.so $RPM_BUILD_ROOT/%{_libexecdir}/litert
install redhat-linux-build/_deps/abseil-cpp-build/absl/strings/libabsl_strings_internal.so $RPM_BUILD_ROOT/%{_libexecdir}/litert
install redhat-linux-build/_deps/abseil-cpp-build/absl/debugging/libabsl_debugging_internal.so $RPM_BUILD_ROOT/%{_libexecdir}/litert
install redhat-linux-build/_deps/abseil-cpp-build/absl/time/libabsl_time_zone.so $RPM_BUILD_ROOT/%{_libexecdir}/litert
install redhat-linux-build/_deps/abseil-cpp-build/absl/numeric/libabsl_int128.so $RPM_BUILD_ROOT/%{_libexecdir}/litert

install -d $RPM_BUILD_ROOT/%{_libdir}/pkgconfig
install redhat-linux-build/libtensorflow-lite.so $RPM_BUILD_ROOT/%{_libdir}/libtensorflow-lite.so.%{version}
ln -s libtensorflow-lite.so.%{version} $RPM_BUILD_ROOT/%{_libdir}/libtensorflow-lite.so

install %{SOURCE1} $RPM_BUILD_ROOT/%{_libdir}/pkgconfig

patchelf --set-rpath %{_libexecdir}/litert $RPM_BUILD_ROOT/%{_libexecdir}/litert/{libfarmhash.so,libfft2d_fftsg2d.so,libXNNPACK.so,libabsl_raw_hash_set.so,libabsl_hash.so,libabsl_synchronization.so,libabsl_strings.so,libfft2d_fftsg.so,libpthreadpool.so,libcpuinfo.so,libabsl_city.so,libabsl_low_level_hash.so,libabsl_kernel_timeout_internal.so,libabsl_stacktrace.so,libabsl_time.so,libabsl_malloc_internal.so,libabsl_base.so,libabsl_spinlock_wait.so,libabsl_raw_logging_internal.so,libabsl_strings_internal.so,libabsl_debugging_internal.so,libabsl_time_zone.so,libabsl_int128.so} $RPM_BUILD_ROOT/%{_libdir}/libtensorflow-lite.so.%{version}

%check
%ctest

%files
%license LICENSE
%dir %{_libexecdir}/litert
%{_libexecdir}/litert/libfarmhash.so
%{_libexecdir}/litert/libfft2d_fftsg2d.so
%{_libexecdir}/litert/libXNNPACK.so
%{_libexecdir}/litert/libabsl_raw_hash_set.so
%{_libexecdir}/litert/libabsl_hash.so
%{_libexecdir}/litert/libabsl_synchronization.so
%{_libexecdir}/litert/libabsl_strings.so
%{_libexecdir}/litert/libfft2d_fftsg.so
%{_libexecdir}/litert/libpthreadpool.so
%{_libexecdir}/litert/libcpuinfo.so
%{_libexecdir}/litert/libabsl_city.so
%{_libexecdir}/litert/libabsl_low_level_hash.so
%{_libexecdir}/litert/libabsl_kernel_timeout_internal.so
%{_libexecdir}/litert/libabsl_stacktrace.so
%{_libexecdir}/litert/libabsl_time.so
%{_libexecdir}/litert/libabsl_malloc_internal.so
%{_libexecdir}/litert/libabsl_base.so
%{_libexecdir}/litert/libabsl_spinlock_wait.so
%{_libexecdir}/litert/libabsl_raw_logging_internal.so
%{_libexecdir}/litert/libabsl_strings_internal.so
%{_libexecdir}/litert/libabsl_debugging_internal.so
%{_libexecdir}/litert/libabsl_time_zone.so
%{_libexecdir}/litert/libabsl_int128.so
%{_libdir}/libtensorflow-lite.so.%{version}

%files devel
%doc tensorflow/lite/c/README.md
%dir %{_includedir}/tensorflow
%dir %{_includedir}/tensorflow/lite
%dir %{_includedir}/tensorflow/lite/c
%dir %{_includedir}/tensorflow/lite/core
%dir %{_includedir}/tensorflow/lite/core/async
%dir %{_includedir}/tensorflow/lite/core/async/c
%dir %{_includedir}/tensorflow/lite/core/c
%dir %{_includedir}/tensorflow/lite/delegates
%dir %{_includedir}/tensorflow/lite/delegates/external
%{_includedir}/tensorflow/lite/*.h
%{_includedir}/tensorflow/lite/c/*.h
%{_includedir}/tensorflow/lite/core/async/c/*.h
%{_includedir}/tensorflow/lite/core/c/*.h
%{_includedir}/tensorflow/lite/delegates/external/*.h
%{_libdir}/libtensorflow-lite.so
%{_libdir}/pkgconfig/litert.pc

%changelog
* Wed Oct 09 2024 Thomas Sailer <fedora@tsailer.ch> - 2.17.0-1
- initial package
